<template>

<div>
     
 <!-- блок кнопок -->
  <div style= "height: 10%"> 
    <dx-button
      icon=""
      type="default"
      text="Получить данные"

      @click="onGetDataSource"
    />

    <dx-button
      icon=""
      type="default"
      text="Очистить данные"
      @click="onClearDataSource"
    />

  </div> 

  <br/>  

  <!-- грид -->
  <div  :style = "{height: windowHeight + 'px'}">   
  <dx-data-grid
    id="gridContainer"  
    key-expr="ID"  
    style= "height: 100%"
     
    :data-source="dataSource"
    :customize-columns="customizeColumns"
    :show-borders="true"
    :focused-row-enabled="true"  
    :allow-column-reordering="true"
    :row-alternation-enabled="false"    
    :showRowHeaders="true"    
    :allowColumnResizing="true"    
    :showRowLines="true"
    :showColumnLines="true"
    @content-ready="onContentReady"    
    @cell-prepared="onCellRrepared"    
  >
    <!-- columns="columns" -->

    <dx-column
        caption="ID"
        data-field="ID"
        alignment="center"
    />

    <dx-column
        caption="Компания"
        data-field="CompanyName"
    />

    <dx-column
        caption="Город"
        data-field="City"
    />

    <dx-column
        caption="Штат"
        data-field="State"
    />

    <dx-column
        caption="Телефон"
        data-field="Phone"
    />

    <dx-column
        caption="Факс"
        data-field="Fax"
        alignment="left"
    />

    <!--
    <dx-header-filter
      :visible="false"
      :allow-search="false"
    />
     -->
    <dx-pager
      :show-page-size-selector="true"
      :allowed-page-sizes="[5, 10, 15, 30]"
      :show-info="true"
     />
    <dx-paging :page-size="30"/>
    <!--<dx-filter-row :visible="true"/> -->
    <!--<dx-header-filter :group-interval="1000"/> -->

  </dx-data-grid>

  </div>
  </div>  
</template>

<script>

import 'devextreme/dist/css/dx.common.css';
import 'devextreme/dist/css/dx.light.compact.css';

import { DxDataGrid, DxColumn, DxExport, DxEditing, DxGrouping,  DxPager, DxPaging, DxColumnChooser, DxFilterRow, DxHeaderFilter, DxSearchPanel} from 'devextreme-vue/data-grid';
import { DxButton } from 'devextreme-vue';
import notify from 'devextreme/ui/notify';


//import { customers } from '~/components/data.js';
//import axios from 'axios'

const windowHeightDefault = 200;


export default {
  components: {
    DxDataGrid,  DxPager, DxPaging, DxColumn, 
    DxButton
  },
  data() {
    return {
      dataSource: '',
      windowHeight: window.innerHeight - windowHeightDefault,
      txt1: ''      
    };
  },

  methods: {   
    //событие
    onContentReady(e) {
      //console.log('onContentReady1');      
      e.component.option('loadPanel.enabled', false);
    },

    //  
    customizeColumns(columns) {
      columns[0].width = 100;
     // columns[0].alignment="center" 
    },


    // событие CellRrepared
    onCellRrepared (e) {
      //console.log(e.cellElement)
      // заголовок грида. alignment header ставим по центру
      if (e.rowType !== "header")
         return;
      e.cellElement.style = "text-align: center;"
      },
  
    onGetDataSource() {
      notify('Получаем данные', 'success', 600);
      this. getDataSource();

    },

    onClearDataSource() {
      notify('Удаляем данные', 'warning', 600);
      this.dataSource = null;

    },  

    getDataSource(){
      //обращаемся к бэку 
      var http = new XMLHttpRequest();
      http.open( "GET", '/api/values', false ); // false for synchronous request  
      http.send(null);
      this.dataSource = JSON.parse(http.responseText);  
    }

  },

  watch: {
    windowHeight(newHeight, oldHeight) {
     this.txt1 = `it changed to ${newHeight} from ${oldHeight}`;
    }
  }, 

  mounted() {
     this.getDataSource();

        //создаем событие на изменения размера страницы
      this.$nextTick(() => {
        window.addEventListener('resize', () => {
          this.windowHeight = window.innerHeight - windowHeightDefault;
        });
      })
      console.log(this.windowHeight);   
  }
};

</script>


<style >

  .dx-datagrid-headers  .dx-row:last-child td  {

    /*
    border-top: 1px solid rgb(153, 152, 167);
    border-right: 1px solid rgb(153, 152, 167);
    border-left: 1px solid rgb(153, 152, 167);
    border-bottom: 1px solid rgb(153, 152, 167);
    
    */
    color: #000000;
    background-color: #d2d3e4 ;
    font-size: 13px;

    
  }

  /* установим в кнопках нижний регистр */
  .dx-button-text {
      text-transform: lowercase;
  }

  /* установим в кнопках первый символ в верхнем регистре */
  .dx-button-text:first-letter {
      text-transform: uppercase;
  }
</style>
